# coding: utf-8

# flake8: noqa
"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: v1.33.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from overseerr.models.cast import Cast
from overseerr.models.collection import Collection
from overseerr.models.company import Company
from overseerr.models.create_auth_local_request import CreateAuthLocalRequest
from overseerr.models.create_auth_logout2_xx_response import CreateAuthLogout2XXResponse
from overseerr.models.create_auth_plex_request import CreateAuthPlexRequest
from overseerr.models.create_auth_reset_password_by_guid_request import CreateAuthResetPasswordByGuidRequest
from overseerr.models.create_auth_reset_password_request import CreateAuthResetPasswordRequest
from overseerr.models.create_discover_add_request import CreateDiscoverAddRequest
from overseerr.models.create_issue_comment_request import CreateIssueCommentRequest
from overseerr.models.create_issue_request import CreateIssueRequest
from overseerr.models.create_jobs_schedule_request import CreateJobsScheduleRequest
from overseerr.models.create_media_by_status_request import CreateMediaByStatusRequest
from overseerr.models.create_plex_sync_request import CreatePlexSyncRequest
from overseerr.models.create_request_request import CreateRequestRequest
from overseerr.models.create_request_request_seasons import CreateRequestRequestSeasons
from overseerr.models.create_user_import_from_plex_request import CreateUserImportFromPlexRequest
from overseerr.models.create_user_register_push_subscription_request import CreateUserRegisterPushSubscriptionRequest
from overseerr.models.create_user_request import CreateUserRequest
from overseerr.models.create_user_settings_main_request import CreateUserSettingsMainRequest
from overseerr.models.create_user_settings_password_request import CreateUserSettingsPasswordRequest
from overseerr.models.create_user_settings_permissions_request import CreateUserSettingsPermissionsRequest
from overseerr.models.credit_cast import CreditCast
from overseerr.models.credit_crew import CreditCrew
from overseerr.models.crew import Crew
from overseerr.models.discord_settings import DiscordSettings
from overseerr.models.discord_settings_options import DiscordSettingsOptions
from overseerr.models.discover_slider import DiscoverSlider
from overseerr.models.episode import Episode
from overseerr.models.external_ids import ExternalIds
from overseerr.models.genre import Genre
from overseerr.models.get_about2_xx_response import GetAbout2XXResponse
from overseerr.models.get_cache2_xx_response import GetCache2XXResponse
from overseerr.models.get_cache2_xx_response_api_caches_inner import GetCache2XXResponseApiCachesInner
from overseerr.models.get_cache2_xx_response_api_caches_inner_stats import GetCache2XXResponseApiCachesInnerStats
from overseerr.models.get_cache2_xx_response_image_cache import GetCache2XXResponseImageCache
from overseerr.models.get_cache2_xx_response_image_cache_tmdb import GetCache2XXResponseImageCacheTmdb
from overseerr.models.get_discover_movies2_xx_response import GetDiscoverMovies2XXResponse
from overseerr.models.get_discover_movies_genre_by_genre_id2_xx_response import GetDiscoverMoviesGenreByGenreId2XXResponse
from overseerr.models.get_discover_movies_language_by_language2_xx_response import GetDiscoverMoviesLanguageByLanguage2XXResponse
from overseerr.models.get_discover_movies_studio_by_studio_id2_xx_response import GetDiscoverMoviesStudioByStudioId2XXResponse
from overseerr.models.get_discover_tv2_xx_response import GetDiscoverTv2XXResponse
from overseerr.models.get_discover_tv_genre_by_genre_id2_xx_response import GetDiscoverTvGenreByGenreId2XXResponse
from overseerr.models.get_discover_tv_language_by_language2_xx_response import GetDiscoverTvLanguageByLanguage2XXResponse
from overseerr.models.get_discover_tv_network_by_network_id2_xx_response import GetDiscoverTvNetworkByNetworkId2XXResponse
from overseerr.models.get_issue2_xx_response import GetIssue2XXResponse
from overseerr.models.get_issue_count2_xx_response import GetIssueCount2XXResponse
from overseerr.models.get_media2_xx_response import GetMedia2XXResponse
from overseerr.models.get_media_watch_data2_xx_response import GetMediaWatchData2XXResponse
from overseerr.models.get_media_watch_data2_xx_response_data import GetMediaWatchData2XXResponseData
from overseerr.models.get_movie_ratings2_xx_response import GetMovieRatings2XXResponse
from overseerr.models.get_person_combined_credits2_xx_response import GetPersonCombinedCredits2XXResponse
from overseerr.models.get_plex_sync2_xx_response import GetPlexSync2XXResponse
from overseerr.models.get_request_count2_xx_response import GetRequestCount2XXResponse
from overseerr.models.get_search2_xx_response import GetSearch2XXResponse
from overseerr.models.get_search2_xx_response_results_inner import GetSearch2XXResponseResultsInner
from overseerr.models.get_search_company2_xx_response import GetSearchCompany2XXResponse
from overseerr.models.get_search_keyword2_xx_response import GetSearchKeyword2XXResponse
from overseerr.models.get_service_radarr_by_radarr_id2_xx_response import GetServiceRadarrByRadarrId2XXResponse
from overseerr.models.get_service_sonarr_by_sonarr_id2_xx_response import GetServiceSonarrBySonarrId2XXResponse
from overseerr.models.get_status2_xx_response import GetStatus2XXResponse
from overseerr.models.get_status_appdata2_xx_response import GetStatusAppdata2XXResponse
from overseerr.models.get_tv_ratings2_xx_response import GetTvRatings2XXResponse
from overseerr.models.get_user2_xx_response import GetUser2XXResponse
from overseerr.models.get_user_quota2_xx_response import GetUserQuota2XXResponse
from overseerr.models.get_user_quota2_xx_response_movie import GetUserQuota2XXResponseMovie
from overseerr.models.get_user_requests2_xx_response import GetUserRequests2XXResponse
from overseerr.models.get_user_settings_main2_xx_response import GetUserSettingsMain2XXResponse
from overseerr.models.get_user_settings_password2_xx_response import GetUserSettingsPassword2XXResponse
from overseerr.models.get_user_settings_permissions2_xx_response import GetUserSettingsPermissions2XXResponse
from overseerr.models.get_user_watch_data2_xx_response import GetUserWatchData2XXResponse
from overseerr.models.get_user_watchlist2_xx_response import GetUserWatchlist2XXResponse
from overseerr.models.get_user_watchlist2_xx_response_results_inner import GetUserWatchlist2XXResponseResultsInner
from overseerr.models.gotify_settings import GotifySettings
from overseerr.models.gotify_settings_options import GotifySettingsOptions
from overseerr.models.issue import Issue
from overseerr.models.issue_comment import IssueComment
from overseerr.models.job import Job
from overseerr.models.keyword import Keyword
from overseerr.models.list_discover_genreslider_movie2_xx_response_inner import ListDiscoverGenresliderMovie2XXResponseInner
from overseerr.models.list_genres_movie2_xx_response_inner import ListGenresMovie2XXResponseInner
from overseerr.models.list_genres_tv2_xx_response_inner import ListGenresTv2XXResponseInner
from overseerr.models.list_languages2_xx_response_inner import ListLanguages2XXResponseInner
from overseerr.models.list_logs2_xx_response_inner import ListLogs2XXResponseInner
from overseerr.models.list_plex_users2_xx_response_inner import ListPlexUsers2XXResponseInner
from overseerr.models.list_regions2_xx_response_inner import ListRegions2XXResponseInner
from overseerr.models.luna_sea_settings import LunaSeaSettings
from overseerr.models.luna_sea_settings_options import LunaSeaSettingsOptions
from overseerr.models.main_settings import MainSettings
from overseerr.models.media_info import MediaInfo
from overseerr.models.media_request import MediaRequest
from overseerr.models.media_request_modified_by import MediaRequestModifiedBy
from overseerr.models.movie_details import MovieDetails
from overseerr.models.movie_details_collection import MovieDetailsCollection
from overseerr.models.movie_details_credits import MovieDetailsCredits
from overseerr.models.movie_details_production_countries_inner import MovieDetailsProductionCountriesInner
from overseerr.models.movie_details_releases import MovieDetailsReleases
from overseerr.models.movie_details_releases_results_inner import MovieDetailsReleasesResultsInner
from overseerr.models.movie_details_releases_results_inner_release_dates_inner import MovieDetailsReleasesResultsInnerReleaseDatesInner
from overseerr.models.movie_result import MovieResult
from overseerr.models.network import Network
from overseerr.models.notification_agent_types import NotificationAgentTypes
from overseerr.models.notification_email_settings import NotificationEmailSettings
from overseerr.models.notification_email_settings_options import NotificationEmailSettingsOptions
from overseerr.models.page_info import PageInfo
from overseerr.models.person_details import PersonDetails
from overseerr.models.person_result import PersonResult
from overseerr.models.person_result_known_for_inner import PersonResultKnownForInner
from overseerr.models.plex_connection import PlexConnection
from overseerr.models.plex_device import PlexDevice
from overseerr.models.plex_library import PlexLibrary
from overseerr.models.plex_settings import PlexSettings
from overseerr.models.production_company import ProductionCompany
from overseerr.models.public_settings import PublicSettings
from overseerr.models.pushbullet_settings import PushbulletSettings
from overseerr.models.pushbullet_settings_options import PushbulletSettingsOptions
from overseerr.models.pushover_settings import PushoverSettings
from overseerr.models.pushover_settings_options import PushoverSettingsOptions
from overseerr.models.put_user_request import PutUserRequest
from overseerr.models.radarr_settings import RadarrSettings
from overseerr.models.related_video import RelatedVideo
from overseerr.models.season import Season
from overseerr.models.servarr_tag import ServarrTag
from overseerr.models.service_profile import ServiceProfile
from overseerr.models.slack_settings import SlackSettings
from overseerr.models.slack_settings_options import SlackSettingsOptions
from overseerr.models.sonarr_series import SonarrSeries
from overseerr.models.sonarr_series_add_options_inner import SonarrSeriesAddOptionsInner
from overseerr.models.sonarr_series_images_inner import SonarrSeriesImagesInner
from overseerr.models.sonarr_series_ratings_inner import SonarrSeriesRatingsInner
from overseerr.models.sonarr_series_seasons_inner import SonarrSeriesSeasonsInner
from overseerr.models.sonarr_settings import SonarrSettings
from overseerr.models.spoken_language import SpokenLanguage
from overseerr.models.tautulli_settings import TautulliSettings
from overseerr.models.telegram_settings import TelegramSettings
from overseerr.models.telegram_settings_options import TelegramSettingsOptions
from overseerr.models.test_radarr2_xx_response import TestRadarr2XXResponse
from overseerr.models.test_radarr_request import TestRadarrRequest
from overseerr.models.test_sonarr_request import TestSonarrRequest
from overseerr.models.tv_details import TvDetails
from overseerr.models.tv_details_content_ratings import TvDetailsContentRatings
from overseerr.models.tv_details_content_ratings_results_inner import TvDetailsContentRatingsResultsInner
from overseerr.models.tv_details_created_by_inner import TvDetailsCreatedByInner
from overseerr.models.tv_result import TvResult
from overseerr.models.update_discover_request import UpdateDiscoverRequest
from overseerr.models.update_issue_comment_request import UpdateIssueCommentRequest
from overseerr.models.update_request_request import UpdateRequestRequest
from overseerr.models.user import User
from overseerr.models.user_settings import UserSettings
from overseerr.models.user_settings_notifications import UserSettingsNotifications
from overseerr.models.watch_provider_details import WatchProviderDetails
from overseerr.models.watch_provider_region import WatchProviderRegion
from overseerr.models.watch_providers_inner import WatchProvidersInner
from overseerr.models.web_push_settings import WebPushSettings
from overseerr.models.webhook_settings import WebhookSettings
from overseerr.models.webhook_settings_options import WebhookSettingsOptions
