# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: v1.33.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from overseerr.models.movie_result import MovieResult
from overseerr.models.person_result import PersonResult
from overseerr.models.tv_result import TvResult
from typing import Union, Any, List, Set, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

GETSEARCH2XXRESPONSERESULTSINNER_ANY_OF_SCHEMAS = ["MovieResult", "PersonResult", "TvResult"]

class GetSearch2XXResponseResultsInner(BaseModel):
    """
    GetSearch2XXResponseResultsInner
    """

    # data type: MovieResult
    anyof_schema_1_validator: Optional[MovieResult] = None
    # data type: TvResult
    anyof_schema_2_validator: Optional[TvResult] = None
    # data type: PersonResult
    anyof_schema_3_validator: Optional[PersonResult] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[MovieResult, PersonResult, TvResult]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: Set[str] = { "MovieResult", "PersonResult", "TvResult" }

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = GetSearch2XXResponseResultsInner.model_construct()
        error_messages = []
        # validate data type: MovieResult
        if not isinstance(v, MovieResult):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MovieResult`")
        else:
            return v

        # validate data type: TvResult
        if not isinstance(v, TvResult):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TvResult`")
        else:
            return v

        # validate data type: PersonResult
        if not isinstance(v, PersonResult):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PersonResult`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in GetSearch2XXResponseResultsInner with anyOf schemas: MovieResult, PersonResult, TvResult. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[MovieResult] = None
        try:
            instance.actual_instance = MovieResult.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[TvResult] = None
        try:
            instance.actual_instance = TvResult.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[PersonResult] = None
        try:
            instance.actual_instance = PersonResult.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetSearch2XXResponseResultsInner with anyOf schemas: MovieResult, PersonResult, TvResult. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], MovieResult, PersonResult, TvResult]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


