# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: v1.33.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class UpdateRequestRequest(BaseModel):
    """
    UpdateRequestRequest
    """ # noqa: E501
    media_type: StrictStr = Field(alias="mediaType")
    seasons: Optional[List[Union[Annotated[float, Field(strict=True, ge=1)], Annotated[int, Field(strict=True, ge=1)]]]] = None
    is4k: Optional[StrictBool] = None
    server_id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="serverId")
    profile_id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="profileId")
    root_folder: Optional[StrictStr] = Field(default=None, alias="rootFolder")
    language_profile_id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="languageProfileId")
    user_id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="userId")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["mediaType", "seasons", "is4k", "serverId", "profileId", "rootFolder", "languageProfileId", "userId"]

    @field_validator('media_type')
    def media_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['movie', 'tv']):
            raise ValueError("must be one of enum values ('movie', 'tv')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateRequestRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if user_id (nullable) is None
        # and model_fields_set contains the field
        if self.user_id is None and "user_id" in self.model_fields_set:
            _dict['userId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateRequestRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "mediaType": obj.get("mediaType"),
            "seasons": obj.get("seasons"),
            "is4k": obj.get("is4k"),
            "serverId": obj.get("serverId"),
            "profileId": obj.get("profileId"),
            "rootFolder": obj.get("rootFolder"),
            "languageProfileId": obj.get("languageProfileId"),
            "userId": obj.get("userId")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


